﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Data.OleDb;

namespace howto_query_master_detail
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private OleDbConnection Conn;

        // Build the list of students.
        private void Form1_Load(object sender, EventArgs e)
        {
            // Prepare the connection.
            string connect_string =
                "Provider=Microsoft.ACE.OLEDB.12.0;" +
                "Data Source=Students.mdb;" +
                "Mode=Share Deny None";
            Conn = new OleDbConnection(connect_string);

            // List the students.
            ListStudents();
        }

        // List the students in cboStudents.
        private void ListStudents()
        {
            string query = "SELECT StudentId, LastName, FirstName " +
                "FROM Addresses " +
                "ORDER BY LastName, FirstName";
            OleDbCommand cmd = new OleDbCommand(query, Conn);

            Conn.Open();
            using (OleDbDataReader reader = cmd.ExecuteReader())
            {
                while (reader.Read())
                {
                    Student student = new Student(
                        (int)reader.GetValue(0),
                        (string)reader.GetValue(1),
                        (string)reader.GetValue(2));
                    cboStudents.Items.Add(student);
                }
            }
            Conn.Close();            
        }

        // Display the data for the selected student.
        private void cboStudents_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Get the selected student.
            Student student = cboStudents.SelectedItem as Student;

            // Get the rest of the student's address data.
            string address_query = "SELECT Street, City, State, Zip " +
                "FROM Addresses WHERE StudentId=" + student.StudentId;
            OleDbCommand address_cmd = new OleDbCommand(address_query, Conn);

            Conn.Open();
            using (OleDbDataReader reader = address_cmd.ExecuteReader())
            {
                // Get the first (and hopefully last) row.
                if (reader.Read())
                {
                    txtStreet.Text = (string)reader.GetValue(0);
                    txtCity.Text = (string)reader.GetValue(1);
                    txtState.Text = (string)reader.GetValue(2);
                    txtZip.Text = (string)reader.GetValue(3);
                }
            }

            // Get the student's test scores.
            lstScores.Items.Clear();
            string scores_query = "SELECT TestNumber, Score " +
                "FROM TestScores WHERE StudentId=" + student.StudentId + " " +
                "ORDER BY TestNumber";
            OleDbCommand scores_cmd = new OleDbCommand(scores_query, Conn);

            int test_total = 0;
            int num_scores = 0;
            using (OleDbDataReader reader = scores_cmd.ExecuteReader())
            {
                // Get the next row.
                while (reader.Read())
                {
                    lstScores.Items.Add("Test " +
                        (int)reader.GetValue(0) + ": " +
                        (int)reader.GetValue(1));
                    test_total += (int)reader.GetValue(1);
                    num_scores++;
                }
            }
            Conn.Close();

            // Display the calculated average.
            if (num_scores == 0) txtAverage.Text = "0";
            else txtAverage.Text = (test_total / num_scores).ToString("0.0");
        }
    }
}
